Package: org.codehaus.groovy.ant

## [Java] Class RootLoaderRef

- org.codehaus.groovy.ant.RootLoaderRef

- Sets the RootLoader as reference. Reexecution of this task will set a new instance of RootLoader for the reference. arguments:

  - ref
  - classpath
  all arguments are required. As ant requires an AntClassLoader as reference, this will create a RootLoader and set an AntClassLoader as child and stored in the reference. The AntClassLoader instance will not have a classpath nor will it have access to the classpath somehow, all loading is done by the RootLoader parent. To avoid problems with loading classes multiple times and using them at the same time, this task will filter out the ant jars and the commons-logging jars. This only works if the ant jars are starting with "ant-" and the logging jar starts with "commons-logging-". This was needed because if ant wants to access a task argument that uses for example a Path it look for a matching method which includes a matching class. But two classes of the same name with different classloaders are different, so ant would not be able to find the method.
  See Also:
    RootLoader
  Authors:
    Jochen Theodorou

- - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `Path` | `createClasspath()` Adds a path to the classpath.
    `` | `void` | `execute()`
    `` | `void` | `setClasspath(Path classpath)` Set the classpath to be used for this compilation.
    `` | `void` | `setClasspathRef(Reference r)` Adds a reference to a classpath defined elsewhere.
    `` | `void` | `setRef(String n)` sets the name of the reference which should store the Loader

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---

    `class MatchingTask`

    `createInclude, createIncludesFile, createExclude, createExcludesFile, setIncludesfile, setExcludesfile, hasSelectors, selectorCount, selectorElements, appendSelector, createPatternSet, setDefaultexcludes, addAnd, addOr, addNot, addNone, addMajority, addDate, addSize, addDifferent, addFilename, addCustom, addContains, addPresent, addDepth, addDepend, addContainsRegexp, addModified, setFollowSymlinks, XsetItems, XsetIgnore, getSelectors, addSelector, setProject, add, setCaseSensitive, addType, setExcludes, setIncludes, getTaskName, getOwningTarget, getTaskType, setTaskType, setTaskName, setOwningTarget, getRuntimeConfigurableWrapper, setRuntimeConfigurableWrapper, maybeConfigure, reconfigure, perform, bindToOwner, log, log, log, log, init, execute, setLocation, clone, getLocation, getDescription, setDescription, getProject, equals, toString, hashCode, getClass, notify, notifyAll, wait, wait, wait`

    `class Task`

    `getTaskName, getOwningTarget, getTaskType, setTaskType, setTaskName, setOwningTarget, getRuntimeConfigurableWrapper, setRuntimeConfigurableWrapper, maybeConfigure, reconfigure, perform, bindToOwner, log, log, log, log, init, execute, setProject, setLocation, clone, getLocation, getDescription, setDescription, getProject, equals, toString, hashCode, getClass, notify, notifyAll, wait, wait, wait`

- - ### Method Detail

    - #### public Path createClasspath()

      Adds a path to the classpath.

      Returns:
        a class path to be configured

    - #### public void execute()

    - #### public void setClasspath(Path classpath)

      Set the classpath to be used for this compilation.

      Parameters:
        `classpath` - an Ant Path object containing the compilation classpath.

    - #### public void setClasspathRef(Reference r)

      Adds a reference to a classpath defined elsewhere.

      Parameters:
        `r` - a reference to a classpath

    - #### public void setRef(String n)

      sets the name of the reference which should store the Loader